#INCLUDE <HMG.CH>

*    Original Example of Franco Bushie  Canada
*    Modified by         Mustafa Lpez  Alicante (Spain)
  
*-----------------------------------------------*
FUNCTION MAIN   
*-----------------------------------------------*

  REQUEST HB_LANG_ESWIN
  REQUEST HB_CODEPAGE_ESWIN
  HB_CDPSELECT('ESWIN')
  HB_LANGSELECT('ESWIN')
*------------------------------------------------------------------*
  SET CODEPAGE TO SPANISH
  SET LANGUAGE TO SPANISH
  SET EXCLUSIVE ON  
  SET CENTURY ON
  SET DATE FRENCH
  SET DATE FORMAT TO 'dd/mm/yyyy'
  SET EPOCH TO 2000
  SET ESCAPE ON
  SET DELETED ON
  SET NAVIGATION EXTENDED
  SET SOFTSEEK ON  
  SET DECIMALS TO 0
  SET TOOLTIPSTYLE BALLOON
*-----------------------------------------------------------------*

  PRIVATE numeroX, numeroQ , cNunPho,  McFileD , cFileName
  PRIVATE MWinCol  , MWinRow ,  hBitmap , cFilPdf ,Nuevo

  IF ! HB_DirExists( "Photo")
     CREATEFOLDER(GETCURRENTFOLDER()+"\Photo\")
  ENDIF

  IF !FILE('WEBCAM.HTML')
	WEBCAM("WEBCAM","CAMERA.SWF","300","300")
  ENDIF

  IF FILE("numerato.mem")
     RESTORE FROM numerato.mem ADDITIVE
  ELSE
     IniTiux()   
  ENDIF

  DEFINE WINDOW CAMFORM AT 0, 0 WIDTH 321 HEIGHT 380 TITLE 'Shot Image' ICON 'Logo' MAIN NOSYSMENU TOPMOST NOMINIMIZE NOMAXIMIZE NOSIZE 

     ON KEY ESCAPE ACTION CAMFORM.RELEASE   

     DEFINE TIMER Timer_2abQ   ;
                  INTERVAL 100 ;
                  ACTION { || thisWindow.Row := 219, thisWindow.Col := 515 }     

     DEFINE ACTIVEX ACTIVEX2
        ROW     010
        COL     007
        WIDTH   300
        HEIGHT  230
        PROGID "SHELL.EXPLORER.2"
     END ACTIVEX

     DEFINE PLAYER Player_1
        ROW    0
        COL    0
        WIDTH  0
        HEIGHT 0
        FILE ''
        HELPID Nil
        NOAUTOSIZEWINDOW .F.            
        NOAUTOSIZEMOVIE .F.              
        NOERRORDLG .F.
        NOMENU .F.
        NOOPEN .F.
        NOPLAYBAR .T.
        SHOWALL .F.
        SHOWMODE .F.
        SHOWNAME .F.                  
        SHOWPOSITION .F.
     END PLAYER

     DEFINE BUTTON BUTTON1
        ROW    253
        COL    030
        WIDTH  110
        HEIGHT 028
        ACTION CAMFORM.RELEASE      
        CAPTION SPACE(5)-"Exit"
        FONTNAME "Arial"
        FONTSIZE 10
        FONTBOLD .T.
        FONTITALIC .F.
        PICTURE "Resource\Cancel1.bmp"
        PICTALIGNMENT LEFT 
     END BUTTON

     DEFINE BUTTON BUTTON2
        ROW    253
        COL    170
        WIDTH  110
        HEIGHT 028
        ACTION ( TAKEPICTURE() , SNAPSHOT(cNunPho )  )
        CAPTION SPACE(5)-"SnapShot"
        FONTNAME "Arial"
        FONTSIZE 10
        FONTBOLD .T.
        FONTITALIC .F.
        PICTURE "Resource\MaqFot1.bmp"
        PICTALIGNMENT LEFT     
     END BUTTON

     DEFINE BUTTON BUTTON3
        ROW    300
        COL    030
        WIDTH  110
        HEIGHT 28
        ACTION PRINTPDF_1()  
        CAPTION SPACE(5)-"Print"
        FONTNAME "Arial"
        FONTSIZE 10
        FONTBOLD .T.
        FONTITALIC .F.
        PICTURE "Resource\Print.bmp"
        PICTALIGNMENT LEFT     
     END BUTTON

     DEFINE BUTTON BUTTON4
        ROW    300
        COL    170
        WIDTH  110
        HEIGHT 28
        ACTION PrintPDF_2()  
        CAPTION "Print-Pdf"
        FONTNAME "Arial"
        FONTSIZE 10
        FONTBOLD .T.
        FONTITALIC .F.
        PICTURE "Resource\Print.bmp"
        PICTALIGNMENT LEFT     
     END BUTTON


   END WINDOW

	CAMFORM.ACTIVEX2.OBJECT:NAVIGATE(GETCURRENTFOLDER()+"\WEBCAM.HTML")
	CAMFORM.CENTER
	CAMFORM.ACTIVATE

RETURN


*-----------------------------------------*
  FUNCTION TAKEPICTURE() 
*-----------------------------------------*

  RESTORE FROM numerato.mem ADDITIVE
   
  numeroQ   := ALLTRIM( STRZERO( apar_5 ,5) )
  cNunPho   := "Photo\"+ numeroQ +".jpg"
  cFileName := "Photo\"+ numeroQ +".jpg"    

* Nuevo =  LEFT (  cFileName  , LEN(  cFileName  ) - 4 )  

  apar_5 := apar_5 + 1 
  apar_2 := STRZERO( apar_5 ,5)     
  apar_3 := DTOC(DATE())
  apar_4 := TIME()
 
  SAVE TO numerato.mem ALL LIKE apar_*

  WEBCAM("WEBCAM","CAMERA.SWF","250","300")     // "300","300")

RETURN
		
*---------------------------------*
FUNCTION SNAPSHOT(cNunPho )  
*----------------------------------*

   CAMFORM.CAPTURE( cNunPho , 15, 7, 300, 220) 
*-----------------------------------------------------------------------------------------------------*

   MWinCol := 300  
   MWinRow := 230 

   hBitmap := BT_BitmapCaptureDesktop()   

   xSAVEWINDOWBYHANDLE ( BT_SCR_GETDESKTOPHANDLE() , cFileName ,255, 518 , MWinCol , MWinRow  )  

   McFileD:= "Resource\iphone-tipear-2.mp3"

   CAMFORM.Player_1.Open (McFileD)
   CAMFORM.Player_1.Play()     

RETURN

*---------------------------------*
FUNCTION WEBCAM
*---------------------------------*

PRIVATE   _cfile, _cimage, _cwidth, _cheight
PARAMETER _cfile, _cimage, _cwidth, _cheight
_cfile:=_cfile + ".html"
TEXT TO FILE &_cfile
<html>
	<body style="overflow: hidden; margin: 0; padding: 0;"
		ondragstart="return false;" ondrop="return false;" oncontextmenu="return false;" onmousedown="return false;">
		<PARAM NAME="SCALE" VALUE="exactfit">
		<embed src="&_cimage" quality="high" type="application/x-shockwave-flash" width="100%" height="100%"
		allowScriptAccess="always" menu="false">
		</body>
</html>
ENDTEXT
RETURN


*---------------------------------*
FUNCTION IniTiux()   
*---------------------------------*
  apar_5 := 1
  apar_2 := STRZERO( apar_5 ,5)     
  apar_3 := DTOC(DATE())
  apar_4 := TIME()
 
  SAVE TO numerato.mem ALL LIKE apar_*


RETURN NIL

*---------------------------------*
FUNCTION PRINTPDF_1()
*---------------------------------*
LOCAL PL

         IF !FILE(cFileName)      
             MsgStop("Error en WebCam","Atencin") 
             Return(.F.)   
         ENDIF

		SELECT  PRINTER DEFAULT TO lSUCCESS preview ;
		ORIENTATION PRINTER_ORIENT_LANDSCAPE        ;          // <---- Opcional    _PORTRAIT ;
		PAPERSIZE PRINTER_PAPER_LETTER              ;
		QUALITY PRINTER_RES_MEDIUM

	
	IF LSUCCESS == .F.
		MSGINFO('Printer Not Available')
		RETURN
	ENDIF
	
          START PRINTDOC
	      START PRINTPAGE
 
		  PL := 8
		@ PL,010 PRINT ' Hello to all:' 
		@ PL,170 PRINT 'Date: '+DTOC(DATE()) SIZE 10
		  PL:= PL+20

		IF FILE("Photo\"+ numeroQ +".jpg")      
	           @ PL,40 PRINT IMAGE getcurrentfolder()+'\Photo\'+numeroQ+'.jpg' WIDTH 80 HEIGHT 60 TYPE JPG  
		ENDIF 

		@ 100,90 PRINT 'End of Report:'

             END PRINTPAGE
	  END PRINTDOC

Return Nil

*----------------------------------------------------------------------------------------------*
FUNCTION PrintPDF_2() 
*----------------------------------------------------------------------------------------------*

   IF !FILE(cFileName)
       mSGsTOP("Error en WebCam","Atencin") 
       Return(.F.)   
   ELSE
       Nuevo =  LEFT (  cFileName  , LEN(  cFileName  ) - 4 )  
       cFilPdf := Nuevo +".pdf"
   ENDIF

*----------------------------------------------------------------------------------------------*

   SELECT HPDFDOC cFilPdf PAPERSIZE HPDF_PAPER_LEGAL

  * SET HPDFDOC ENCODING TO "WinAnsiEncoding"
  * SET HPDFDOC ENCODING TO "CP1252"  
*----------------------------------------------------------------------------------------------*
      START HPDFDOC
          START HPDFPAGE

              @ 60,70 HPDFPRINT IMAGE getcurrentfolder()+'\Photo\'+numeroQ+'.jpg' WIDTH 80 HEIGHT 60 TYPE JPG  

         END HPDFPAGE  
      END HPDFDOC  
 
  CAMFORM.Minimize

  Execute file cFilPdf

Return Nil

*________________________________________________________________________________________________________________________________*
*___________________________________________  Courtesy of Roberto Lpez and Bicahi Esgici _______________________________________*
*________________________________________________________________________________________________________________________________*

*-------------------------------------------------------------------------------------*
FUNCTION xSAVEWINDOWBYHANDLE ( nHandle , cFileName , nRow , nCol , nWidth , nHeight )
*-------------------------------------------------------------------------------------*

   hBitmap := xBT_BITMAPCAPTURECLIENTAREA ( nHandle , nRow, nCol, nWidth, nHeight)

   IF hBitmap <> 0
      IF   UPPER(RIGHT( cFileName , 4 ) ) == '.JPG'
           xBT_BITMAPSAVEFILE (hBitmap, cFileName , BT_FILEFORMAT_JPG )
      ENDIF
          xBT_BITMAPRELEASE (hBitmap)
   ENDIF

RETURN hBitmap

*------------------------------------------------------------------------------------------------------*
FUNCTION xBT_BitmapCaptureClientArea ( nHandle , Row, Col, Width, Height)
*------------------------------------------------------------------------------------------------------*
   LOCAL New_hBitmap
   LOCAL Max_Width  := BT_ClientAreaWidth( nHandle )
   LOCAL Max_Height := BT_ClientAreaHeight( nHandle )
   bt_FillRectIsNIL (@Row, @Col, @Width, @Height, 0, 0, Max_Width, Max_Height)   
   bt_AdjustWidthHeightRect (Row, Col, @Width, @Height, Max_Width, Max_Height)      
   New_hBitmap := BT_BMP_CAPTURESCR ( nHandle , Col, Row, Width, Height, BT_BITMAP_CAPTURE_DESKTOP)
Return New_hBitmap

*------------------------------------------------------------------------------------------------------*
FUNCTION xBT_BitmapSaveFile (hBitmap, cFileName, nTypePicture)
*------------------------------------------------------------------------------------------------------*
   LOCAL lRet
   nTypePicture := IF (Valtype(nTypePicture) == "U", BT_FILEFORMAT_BMP, nTypePicture)
   lRet := BT_BMP_SAVEFILE (hBitmap, cFileName, nTypePicture)
Return lRet

*------------------------------------------------------------------------------------------------------*
FUNCTION xBT_BitmapRelease (hBitmap)
*------------------------------------------------------------------------------------------------------*
   BT_BMP_RELEASE (hBitmap)
Return Nil

*------------------------------------------------------------------------------------------------------*
FUNCTION xBT_ClientAreaWidth ( nHandle )
*------------------------------------------------------------------------------------------------------*
   LOCAL Width := BT_SCR_GETINFO ( nHandle , BT_SCR_CLIENTAREA, BT_SCR_INFO_WIDTH)   
Return Width

*------------------------------------------------------------------------------------------------------*
FUNCTION xBT_ClientAreaHeight ( nHandle )
*------------------------------------------------------------------------------------------------------*
   LOCAL Height := BT_SCR_GETINFO ( nHandle , BT_SCR_CLIENTAREA, BT_SCR_INFO_HEIGHT)      
Return Height

*------------------------------------------------------------------------------------------------------*
FUNCTION xBT_FillRectIsNIL (Row, Col, Width, Height, Row_value, Col_value, Width_value, Height_value)
*------------------------------------------------------------------------------------------------------*
   Row    := IF (Valtype(Row)    =="U",  Row_value,    Row)
   Col    := IF (Valtype(Col)    =="U",  Col_value,    Col)
   Width  := IF (Valtype(Width)  =="U",  Width_value,  Width)
   Height := IF (Valtype(Height) =="U",  Height_value, Height)   
Return Nil

*------------------------------------------------------------------------------------------------------*
FUNCTION xBT_AdjustWidthHeightRect (Row, Col, Width, Height, Max_Width, Max_Height)
*------------------------------------------------------------------------------------------------------*
   Width  := IF ((Col + Width  > Max_Width),  (Max_Width  - Col), Width)
   Height := IF ((Row + Height > Max_Height), (Max_Height - Row), Height)
Return Nil

*------------------------------------------------------------------------------------------------------*
FUNCTION  xBT_WinHandle (Win)
*------------------------------------------------------------------------------------------------------*
   LOCAL hWnd := IF (ValType(Win)=="N", Win, GetFormHandle(Win))
Return hWnd

*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*

























































